
#if !defined(_INTEGRATEF_)
#define _INTEGRATEF_
 
#include"Object.h"

// DINTGK1 gauss-kronrot integration of fun(var), var(ivar)=aa(ivar)...bb(ivar)
//         with parallel integration of nfun additional functions cf

extern "C" void FortranCall(dintgk1a)(double (*func)(double* VAR,double* CF,
                                      void *This),
                                   //(1)  return the value of the function fun
                                   //     on point VAR. CF is the return values
                                   //     on the additionals functions on this
			 	   //     point
          int	 *NFUN,            //(2)  number of additional functions
          double VAR[],            //     point where the function has to be 
                                   //(3)  evaluate
          int    *IVAR,            //(4)  index of the function to integrate
          double AA[],             //(5)  lower limit              
          double BB[],             //(6)  upper limit
          int    *IPT,             //(7)  1,2...6 for 15,21,31,41,51,61 points
				   //     integration    
          int    *IFCM,            //(8)  maximal number of function call
          double *ACCREL,          //(9)  relative accuracy
          double RESULT[],         //(10) approximation af the integrals 
                                   //     RESULT[0] integral of fun
                                   //     RESULT[1..nfun] integral of CF
          int    *m,               //(11) number of function calls
          int    *OK,              //(12)  
                 //OK=0 normal and reliable termination of the routine
                 //   1 maximum number of subdivisions (limit=512) has been 
                 //     archieved
                 //   2 the occurrence of roundoff error is detected
                 //   3 extremely bad integrand behaviour occurs at some points
                 //   4 itm too small for n-th approximation
                 //   5 itm too small for first approximation
                 //  -1 epsrel too small, minimum value assumed
                 //  -2 key too small, minimum value assumed: key=1
                 //  -3 key too large, maximum value assumed: key=6
                 //OK>5 nfun exceeds limit, IOK=limit
          void   *This             //(13) pointer that will be transfered to
                                   //     the function func
            			  ) ;
extern "C" void FortranCall(dintgk1b)
                          (double (*func)(double* VAR,double* CF,void *This),
                          int *NFUN, double VAR[], int *IVAR, double AA[],
                          double BB[], int    *IPT, int *IFCM, double *ACCREL,
                          double RESULT[], int *m, int    *OK, void *This) ;
extern "C" void FortranCall(dintgk1c)
                         (double (*func)(double* VAR,double* CF,void *This),
                          int *NFUN, double VAR[], int *IVAR, double AA[],
                          double BB[], int    *IPT, int *IFCM, double *ACCREL,
                          double RESULT[], int *m, int    *OK, void *This) ;
extern "C" void FortranCall(dintgk1d)
                         (double (*func)(double* VAR,double* CF,void *This),
                          int *NFUN, double VAR[], int *IVAR, double AA[],
                          double BB[], int    *IPT, int *IFCM, double *ACCREL,
                          double RESULT[], int *m, int    *OK, void *This) ;
extern "C" void FortranCall(dintgk1e)
                         (double (*func)(double* VAR,double* CF,void *This),
                          int *NFUN, double VAR[], int *IVAR, double AA[],
                          double BB[], int    *IPT, int *IFCM, double *ACCREL,
                          double RESULT[], int *m, int    *OK, void *This) ;
 
#endif
