#define TRIPLETSTRLENGTH 128

template<class TYPE>
ostream& operator<<(ostream& Cout,const Triplet<TYPE>& T)

{ T.Write(Cout); 
  return Cout;
}

template<class TYPE>
istream& operator>>(istream& Cin,Triplet<TYPE>& T)

{ int err=T.Read(Cin); 
  if (err) Cin.clear(ios::badbit);

  return Cin;
}

template<class TYPE>
Triplet<TYPE> MakeTriplet(const TYPE& t)

{ return Triplet<TYPE>(t,t,t);
}

template<class TYPE>
int Triplet<TYPE>::Read(istream& Cin)

{ char String[TRIPLETSTRLENGTH], Strtmp[TRIPLETSTRLENGTH];
  char *strptr;

  int Scalar=0;  
  String[0]=0;

  Cin>>Strtmp;

  if(strchr(Strtmp,'[')==0) Scalar=1;

  if(Scalar)
    {
    TYPE D;
    istrstream IstS(Strtmp,TRIPLETSTRLENGTH);
    IstS>>D;
    x=y=z=D;
    }
  else
    {
    strncat(String,Strtmp,TRIPLETSTRLENGTH);
    int n=0;

    while ((strchr(String,']')==0) && (n<10))
      {
      Cin>>Strtmp;
      strncat(String,Strtmp,TRIPLETSTRLENGTH);
      n++;
      }
    if(n==9) return -1;

    strptr=strchr(String,'[');
    if(strptr==0) return -1;
    strptr++;
    istrstream Ist1(strptr,TRIPLETSTRLENGTH);
    Ist1>>x;    

    strptr=strchr(strptr,',');
    if(strptr==0) return -1;
    strptr++;
    istrstream Ist2(strptr,TRIPLETSTRLENGTH);
    Ist2>>y;    

    strptr=strchr(strptr,',');
    if(strptr==0) return -1;
    strptr++;
    istrstream Ist3(strptr,TRIPLETSTRLENGTH);
    Ist3>>z;    
    }

  return 0;
}

template<class TYPE>
int Triplet<TYPE>::Write(ostream& Cout) const

{ Cout<<"["<<x<<","<<y<<","<<z<<"]";
  return 1;
}

template<class TYPE>
Triplet<TYPE> operator+(const Triplet<TYPE>& t1,const Triplet<TYPE>& t2)

{ return Triplet<TYPE>(t1.x+t2.x,t1.y+t2.y,t1.z+t2.z);
}

template<class TYPE>
Triplet<TYPE> operator-(const Triplet<TYPE>& t1,const Triplet<TYPE>& t2)

{ return Triplet<TYPE>(t1.x-t2.x,t1.y-t2.y,t1.z-t2.z);
}

template<class TYPE>
Triplet<TYPE> operator*(const TYPE s,Triplet<TYPE>& t1)

{ return Triplet<TYPE>(t1.x*s,t1.y*s,t1.z*s);
}

template<class TYPE>
Triplet<TYPE> operator*(const Triplet<TYPE>& t1,TYPE s)

{ return Triplet<TYPE>(t1.x*s,t1.y*s,t1.z*s);
}

template<class TYPE>
Triplet<TYPE> operator-(const Triplet<TYPE>& t1)

{ return Triplet<TYPE>(-t1.x,-t1.y,-t1.z);
}
